LootLink_RefreshOnShow = 0;
LootLink_InspectOnMouseover = 0;

LootLinkExtension_Saved_LootLink_OnShow = nil;
LootLinkExtension_Saved_GameTooltip_SetQuestItem = nil;
LootLinkExtension_Saved_GameTooltip_SetQuestLogItem = nil;
LootLinkExtension_Saved_GameTooltip_SetCraftItem = nil;
LootLinkExtension_Saved_GameTooltip_SetCraftSpell = nil;
LootLinkExtension_Saved_GameTooltip_SetTradeSkillItem = nil;
LootLinkExtension_Saved_GameTooltip_SetTradePlayerItem = nil;
LootLinkExtension_Saved_GameTooltip_SetTradeTargetItem = nil;
LootLinkExtension_Saved_ItemRefTooltip_SetHyperlink = nil;

function LootLinkExtension_OnLoad()
	this:RegisterEvent("MERCHANT_SHOW");
	this:RegisterEvent("MERCHANT_UPDATE");

	LootLinkExtension_CosmosRegister();

	LootLinkExtension_HookFunctions();
end


function LootLinkExtension_CosmosRegister()
	if ( Cosmos_RegisterButton ) then 
		Cosmos_RegisterButton(
			TEXT(COSMOS_LOOTLINK_NAME),
			TEXT(COSMOS_LOOTLINK_SHORT_DESC), 
			TEXT(COSMOS_LOOTLINK_LONG_DESC), 
			TEXT(COSMOS_LOOTLINK_BUTTON_TEXTURE), 
			ToggleLootLink
		);
	end
	if ( Cosmos_RegisterConfiguration ) then 
		Cosmos_RegisterConfiguration(
			"COS_LOOTLINK",
			"SECTION",
			TEXT(COSMOS_LOOTLINK_NAME),
			TEXT(COSMOS_LOOTLINK_LONG_DESC)
		);
		Cosmos_RegisterConfiguration(
			"COS_LOOTLINK_HEADER",
			"SEPARATOR",
			TEXT(COSMOS_LOOTLINK_NAME),
			TEXT(COSMOS_LOOTLINK_LONG_DESC)
		);
		Cosmos_RegisterConfiguration(
			"COS_LOOTLINK_INSPECT_ON_MOUSEOVER",
			"CHECKBOX",
			TEXT(COSMOS_LOOTLINK_INSPECT_ON_MOUSEOVER),
			TEXT(COSMOS_LOOTLINK_INSPECT_ON_MOUSEOVER_INFO),
			LootLink_SetInspectOnMouseover,
			LootLink_InspectOnMouseover
		);
		Cosmos_RegisterConfiguration(
			"COS_LOOTLINK_REFRESHONSHOW",
			"CHECKBOX",
			TEXT(COSMOS_LOOTLINK_REFRESH_ON_OPEN),
			TEXT(COSMOS_LOOTLINK_REFRESH_ON_OPEN_INFO),
			LootLink_SetRefreshOnShow,
			LootLink_RefreshOnShow
		);
	end
end

function LootLinkExtension_OnMerchantEvent()
	LootLink_ScanMerchant();
end

function LootLinkExtension_OnMouseOverUnitEvent()
	if( LootLink_InspectOnMouseover == 1 ) then
		if( UnitIsUnit("mouseover", "player") ) then
			return;
		elseif( UnitIsPlayer("mouseover") ) then
			LootLink_Inspect("mouseover");
		end
	end
end

function LootLinkExtension_OnEvent(event)
	if( ( event == "MERCHANT_SHOW" ) or ( event == "MERCHANT_UPDATE" ) ) then
		LootLinkExtension_OnMerchantEvent();
		return;
	elseif( event == "UPDATE_MOUSEOVER_UNIT" ) then
		LootLinkExtension_OnMouseOverUnitEvent();
		return;
	end
end

function LootLink_ScanMerchant()
	local size;
	local slotid;
	local link;
	
	size = GetMerchantNumItems();
	for slotid = size, 1, -1 do
		local name, _, merchantBuyPrice, quantity = GetMerchantItemInfo(slotid);
		link = GetMerchantItemLink(slotid);
		if( link ) then
			LootLink_ProcessLinks(link);
		end
		if ((ItemLinks[name] ~= nil) and (merchantBuyPrice ~= nil)) then
			local realBuyPrice = merchantBuyPrice;
			if ( quantity > 0 ) then
				realBuyPrice = realBuyPrice / quantity;
			end
			if(ItemLinks[name].buyPrice ~= nil ) then
				if(ItemLinks[name].buyPrice > realBuyPrice) then
  					ItemLinks[name].buyPrice = realBuyPrice;
				end
			else
				ItemLinks[name].buyPrice = realBuyPrice;
			end
			if ( ItemLinks[name].buyPrice ) then
				local newPrice = math.ceil(ItemLinks[name].buyPrice / 4);
				if ( not ItemLinks[name].price ) or ( newPrice < ItemLinks[name].price ) then
					ItemLinks[name].price = newPrice;
				end
			end
		end
	end
end



function LootLink_GetCoinValue(value)
	value = floor(value);
	local gold = floor(value / 10000);
	value = value - gold * 10000;
	local silver = floor(value / 100);
	value = value - silver * 100;
	local str = "";
	if ( gold > 0 ) then
		if ( strlen(str) > 0 ) then str = str.." "; end
		str = str..gold.." g";
	end
	if ( silver > 0 ) then
		if ( strlen(str) > 0 ) then str = str.." "; end
		str = str..silver.." s";
	end
	if ( value > 0 ) then
		if ( strlen(str) > 0 ) then str = str.." "; end
		str = str..value.." c";
	end
	return str;
end

function LootLink_SetRefreshOnShow(toggle)
	if ( toggle ~= LootLink_RefreshOnShow ) then
		LootLink_RefreshOnShow = toggle;
	end
end

function LootLinkExtension_HookFunctions()
	LootLinkExtension_HookLootLinkFunctions();
	
	LootLinkExtension_Saved_GameTooltip_SetQuestItem = GameTooltip.SetQuestItem;
	GameTooltip.SetQuestItem = LootLinkExtension_GameTooltip_SetQuestItem;
	
	LootLinkExtension_Saved_GameTooltip_SetQuestLogItem = GameTooltip.SetQuestLogItem;
	GameTooltip.SetQuestLogItem = LootLinkExtension_GameTooltip_SetQuestLogItem;

	LootLinkExtension_Saved_GameTooltip_SetCraftItem = GameTooltip.SetCraftItem;
	GameTooltip.SetCraftItem = LootLinkExtension_GameTooltip_SetCraftItem;

	LootLinkExtension_Saved_GameTooltip_SetCraftSpell = GameTooltip.SetCraftSpell;
	GameTooltip.SetCraftSpell = LootLinkExtension_GameTooltip_SetCraftSpell;

	LootLinkExtension_Saved_GameTooltip_SetTradeSkillItem = GameTooltip.SetTradeSkillItem;
	GameTooltip.SetTradeSkillItem = LootLinkExtension_GameTooltip_SetTradeSkillItem;

	LootLinkExtension_Saved_GameTooltip_SetTradePlayerItem = GameTooltip.SetTradePlayerItem;
	GameTooltip.SetTradePlayerItem = LootLinkExtension_GameTooltip_SetTradePlayerItem;
	
	LootLinkExtension_Saved_GameTooltip_SetTradeTargetItem = GameTooltip.SetTradeTargetItem;
	GameTooltip.SetTradeTargetItem = LootLinkExtension_GameTooltip_SetTradeTargetItem;
	
	--LootLinkExtension_Saved_ItemRefTooltip_SetHyperlink = ItemRefTooltip.SetHyperlink;
	--ItemRefTooltip.SetHyperlink = LootLinkExtension_ItemRefTooltip_SetHyperlink;
end

function LootLinkExtension_HookLootLinkFunctions()
	LootLinkExtension_Saved_LootLink_OnShow = LootLink_OnShow;
	LootLink_OnShow = LootLinkExtension_LootLink_OnShow;
end

function LootLinkExtension_LootLink_OnShow()
	if ( LootLink_RefreshOnShow == 1 ) then
		LootLink_Refresh();
	end
	LootLinkExtension_Saved_LootLink_OnShow()
end

function LootLinkExtension_GameTooltip_SetQuestItem(tooltip, questItemType, questItemID, ...)
	if ( not tooltip ) then
		return;
	end;
	if ( arg ) then
		LootLinkExtension_Saved_GameTooltip_SetQuestItem(tooltip, questItemType, questItemID, unpack(arg));
	else
		LootLinkExtension_Saved_GameTooltip_SetQuestItem(tooltip, questItemType, questItemID);
	end

	local money = 0;
	local link = GetQuestItemLink(questItemType, questItemID);
	local name = LootLink_ProcessLinks(link);
	if ( not name ) or ( strlen(name) <= 0 ) then
		return;
	end
	
	local otherName, texture, numItems, quality, isUsable = GetQuestItemInfo(questItemType, questItemID);
	
	local count = nil;
	
	if ( otherName == name ) then
		count = numItems;
	end

	local data = nil;
	if (ItemLinks[name]) then data = ItemLinks[name]; end
	if (data and data.price) then money = data.price; end
	if (not count) then count = 1; end

	LootLink_Tooltip_Hook(tooltip, name, money, count, data)
	tooltip:Show();
end


function LootLinkExtension_GameTooltip_SetQuestLogItem(tooltip, questItemType, questItemID, ...)
	if ( not tooltip ) then
		return;
	end;
	if ( arg ) then
		LootLinkExtension_Saved_GameTooltip_SetQuestLogItem(tooltip, questItemType, questItemID, unpack(arg));
	else
		LootLinkExtension_Saved_GameTooltip_SetQuestLogItem(tooltip, questItemType, questItemID);
	end

	local money = 0;
	local link = GetQuestLogItemLink(questItemType, questItemID);
	local name = LootLink_ProcessLinks(link);
	if ( not name ) or ( strlen(name) <= 0 ) then
		return;
	end
	
	local otherName, texture, numItems, quality, isUsable = GetQuestLogChoiceInfo(questItemID);
	
	local count = nil;
	
	if ( otherName == name ) then
		count = numItems;
	end

	local data = nil;
	if (ItemLinks[name]) then data = ItemLinks[name]; end
	if (data and data.price) then money = data.price; end
	if (not count) then count = 1; end

	LootLink_Tooltip_Hook(tooltip, name, money, count, data)
	tooltip:Show();
end

function LootLinkExtension_GameTooltip_SetCraftItem(tooltip, craftSelection, craftItemID, ...)
	if ( not tooltip ) then
		return;
	end;
	if ( arg ) then
		LootLinkExtension_Saved_GameTooltip_SetCraftItem(tooltip, craftSelection, craftItemID, unpack(arg));
	else
		LootLinkExtension_Saved_GameTooltip_SetCraftItem(tooltip, craftSelection, craftItemID);
	end

	local money = 0;
	local link = GetCraftReagentItemLink(craftSelection, craftItemID);
	local name = LootLink_ProcessLinks(link);
	if ( not name ) or ( strlen(name) <= 0 ) then
		return;
	end
	
	local reagentName, reagentTexture, reagentCount, playerReagentCount = GetCraftReagentInfo(craftSelection, craftItemID);
	
	local count = nil;
	
	if ( reagentName == name ) then
		count = reagentCount;
	end

	local data = nil;
	if (ItemLinks[name]) then data = ItemLinks[name]; end
	if (data and data.price) then money = data.price; end
	if (not count) then count = 1; end

	LootLink_Tooltip_Hook(tooltip, name, money, count, data)
	tooltip:Show();
end

function LootLinkExtension_GameTooltip_SetCraftSpell(tooltip, craftSelection, ...)
	if ( not tooltip ) then
		return;
	end;
	if ( arg ) then
		LootLinkExtension_Saved_GameTooltip_SetCraftSpell(tooltip, craftSelection, unpack(arg));
	else
		LootLinkExtension_Saved_GameTooltip_SetCraftSpell(tooltip, craftSelection);
	end

	local craftName, craftSubSpellName, craftType, numAvailable, isExpanded, trainingPointCost, requiredLevel = GetCraftInfo(craftSelection);

	if ( craftType == "header" ) then	
		-- we don't do headers.
		return;
	end

	local money = 0;
	local link = GetCraftItemLink(craftSelection);
	local name = LootLink_ProcessLinks(link);
	if ( not name ) or ( strlen(name) <= 0 ) then
		return;
	end
	
	local count = nil;
	
	if ( craftSubSpellName == name ) then
		--count = 0; -- ? any way to get number of stuff
	end

	local data = nil;
	if (ItemLinks[name]) then data = ItemLinks[name]; end
	if (data and data.price) then money = data.price; end
	if (not count) then count = 1; end

	LootLink_Tooltip_Hook(tooltip, name, money, count, data)
	tooltip:Show();
end


function LootLinkExtension_GameTooltip_SetTradeSkillItem(tooltip, craftSelection, craftItemID, ...)
	if ( not tooltip ) then
		return;
	end;
	if ( arg ) then
		LootLinkExtension_Saved_GameTooltip_SetTradeSkillItem(tooltip, craftSelection, craftItemID, unpack(arg));
	else
		LootLinkExtension_Saved_GameTooltip_SetTradeSkillItem(tooltip, craftSelection, craftItemID);
	end

	local skillName, skillType, numAvailable, isExpanded;
	if ( not craftItemID ) then
		skillName, skillType, numAvailable, isExpanded = GetTradeSkillInfo(craftSelection);
	
		if ( skillType == "header" ) then	
			-- we don't do headers.
			return;
		end
	end


	local money = 0;
	local link = nil;
	if ( not craftItemID ) then
		link = GetTradeSkillItemLink(craftSelection);
	else
		link = GetTradeSkillReagentItemLink(craftSelection, craftItemID);
	end
	local name = LootLink_ProcessLinks(link);
	if ( not name ) or ( strlen(name) <= 0 ) then
		return;
	end
	
	local reagentName, reagentTexture, reagentCount, playerReagentCount;
	if ( craftItemID ) then
		reagentName, reagentTexture, reagentCount, playerReagentCount = GetTradeSkillReagentInfo(craftSelection, craftItemID);
	end
	
	local count = nil;

	if ( not craftItemID ) then
		local minMade,maxMade = GetTradeSkillNumMade(id);	
		if ( skillName == name ) then
			count = minMade;
		end
	else
		if ( reagentName == name ) then
			count = reagentCount;
		end
	end

	local data = nil;
	if (ItemLinks[name]) then data = ItemLinks[name]; end
	if (data and data.price) then money = data.price; end
	if (not count) then count = 1; end

	LootLink_Tooltip_Hook(tooltip, name, money, count, data)
	tooltip:Show();
end

function LootLinkExtension_GameTooltip_SetTradeTargetItem(tooltip, tradeItemID, ...)
	if ( not tooltip ) then
		return;
	end;
	if ( arg ) then
		LootLinkExtension_Saved_GameTooltip_SetTradeTargetItem(tooltip, tradeItemID, unpack(arg));
	else
		LootLinkExtension_Saved_GameTooltip_SetTradeTargetItem(tooltip, tradeItemID);
	end

	local money = 0;
	local link = GetTradeTargetItemLink(tradeItemID);
	local name = LootLink_ProcessLinks(link);
	if ( not name ) or ( strlen(name) <= 0 ) then
		return;
	end
	
	local tradeName, texture, numItems, quality, isUsable, enchantment = GetTradeTargetItemInfo(id);
	
	local count = nil;

	if ( tradeName == name ) then
		count = numItems;
	end

	local data = nil;
	if (ItemLinks[name]) then data = ItemLinks[name]; end
	if (data and data.price) then money = data.price; end
	if (not count) then count = 1; end

	LootLink_Tooltip_Hook(tooltip, name, money, count, data)
	tooltip:Show();
end

function LootLinkExtension_GameTooltip_SetTradePlayerItem(tooltip, tradeItemID, ...)
	if ( not tooltip ) then
		return;
	end;
	if ( arg ) then
		LootLinkExtension_Saved_GameTooltip_SetTradePlayerItem(tooltip, tradeItemID, unpack(arg));
	else
		LootLinkExtension_Saved_GameTooltip_SetTradePlayerItem(tooltip, tradeItemID);
	end

	local money = 0;
	local link = GetTradePlayerItemLink(tradeItemID);
	local name = LootLink_ProcessLinks(link);
	if ( not name ) or ( strlen(name) <= 0 ) then
		return;
	end
	
	local tradeName, texture, numItems, isUsable, enchantment = GetTradePlayerItemInfo(tradeItemID);
	
	local count = nil;

	if ( tradeName == name ) then
		count = numItems;
	end

	local data = nil;
	if (ItemLinks[name]) then data = ItemLinks[name]; end
	if (data and data.price) then money = data.price; end
	if (not count) then count = 1; end

	LootLink_Tooltip_Hook(tooltip, name, money, count, data)
	tooltip:Show();
end

function LootLinkExtension_ItemRefTooltip_SetHyperlink(tooltip, link)
	LootLinkExtension_Saved_ItemRefTooltip_SetHyperlink(tooltip, link);
	local name = LootLink_ProcessLinks(link);

	local data = nil;
	local count = nil;
	if (ItemLinks[name]) then data = ItemLinks[name]; end
	if (data and data.price) then money = data.price; end
	if (not count) then count = 1; end
	LootLink_Tooltip_Hook(tooltip, name, money, count, data)
end
